<?php

	function _get_border($img, $x, $y) {
	
		$border = Array();

		$border[0] = (int)ImageColorAt($img, $x-1, $y-1);
		$border[1] = (int)ImageColorAt($img, $x,   $y-1);
		$border[2] = (int)ImageColorAt($img, $x+1, $y-1);
		$border[3] = (int)ImageColorAt($img, $x+1, $y);
		$border[4] = (int)ImageColorAt($img, $x+1, $y+1);
		$border[5] = (int)ImageColorAt($img, $x,   $y+1);
		$border[6] = (int)ImageColorAt($img, $x-1, $y+1);
		$border[7] = (int)ImageColorAt($img, $x-1, $y);

		return $border;

	}


	function smooth($img, $per) {
	
		$width = imagesx($img);
		$height = imagesy($img);

		for ($i = 0; $i < $width; $i++) {
			for ($j = 0; $j < $height; $j++) {

				$border = _get_border($img, $i, $j);
				$center = ImageColorAt($img, $i, $j);
				$count  = count_in_border($center, $border);
				
				if ( round(($count+1)*100/9) >= $per ) {
					imagesetpixel($img, $i, $j, $center);
				} else {
					$border_color = get_border_color($border, $center);
					imagesetpixel($img, $i, $j, $border_color);
				}

			}
		}

	}




	function count_in_border($center, $border) {
		
		$count = 0;

		foreach ($border as $dot) {
			if ($center == $dot) $count++;
		}
	
		return $count;

	}


	function get_border_color($border, $center) {
	
		foreach ($border as $dot) {
			if ($dot !== $center) return $dot;
		}

		return $center;

	}


?>